// GSDemo.java

import java.awt.EventQueue;
import java.awt.FlowLayout;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import com.sun.stylesheet.Stylesheet;

import com.sun.stylesheet.css.CSSParser;

public class GSDemo extends JFrame
{
   static Stylesheet globalStylesheet;

   public GSDemo ()
   {
      super ("Global Style Sheet Demo");
      setDefaultCloseOperation (EXIT_ON_CLOSE);

      getContentPane ().setLayout (new FlowLayout ());

      getContentPane ().add (new JLabel ("Age"));

      final JTextField txtAge = new JTextField (20);
      getContentPane ().add (txtAge);

      JButton btnValidate = new JButton ("Validate");

      ActionListener al;
      al = new ActionListener ()
           {
               public void actionPerformed (ActionEvent ae)
               {
                  try
                  {
                      Integer.parseInt (txtAge.getText ());
                  }
                  catch (NumberFormatException nfe)
                  {
                      Stylesheet.setGlobalStylesheet (globalStylesheet);
                      JOptionPane.showMessageDialog (GSDemo.this,
                                                     "integer expected");
                  }
               }
           };
      btnValidate.addActionListener (al);
      getContentPane ().add (btnValidate);
   }

   public static void main (String [] args)
   {
      Runnable r;
      r = new Runnable ()
          {
              public void run ()
              {
                 String globalStyling =
                   "JButton { font-size: 16pt; foreground: red; "+
                   "text-decoration: underline }";
                 globalStylesheet = CSSParser.parse (globalStyling);

                 String styling =
                   "JButton { font-size: 16pt; foreground: blue; "+
                   "text-decoration: underline }";
                 Stylesheet stylesheet = CSSParser.parse (styling);
                 GSDemo gsdemo = new GSDemo ();
                 stylesheet.applyTo (gsdemo);
                 gsdemo.pack ();
                 gsdemo.setVisible (true);
              }
          };
      EventQueue.invokeLater (r);
   }
}
