// GPanel.java

import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JPanel;

public class GPanel extends JPanel
{
   private GradientPaint gp;

   private Gradient gradient;

   @Override
   public void paintComponent (Graphics g)
   {
      if (gp == null && gradient != null)
          gp = new GradientPaint (0, 0, gradient.start, 0, getHeight (),
                                  gradient.end);
      if (gp != null)
          ((Graphics2D) g).setPaint (gp);
      else
          g.setColor (getBackground ());
      g.fillRect (0, 0, getWidth (), getHeight ());
   }

   public void setGradient (Gradient gradient)
   {
      this.gradient = gradient;
      gp = null;
      repaint ();
   }

   public Gradient getGradient ()
   {
      return gradient;
   }
}
