// GradientConverter.java

import java.awt.Color;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.sun.stylesheet.types.TypeConverter;

public class GradientConverter implements TypeConverter<Gradient>
{
   private Pattern pattern = Pattern.compile (
        "(#[A-Fa-f\\d][A-Fa-f\\d][A-Fa-f\\d][A-Fa-f\\d][A-Fa-f\\d][A-Fa-f\\d])"+
        "\\s*,\\s*"+
        "(#[A-Fa-f\\d][A-Fa-f\\d][A-Fa-f\\d][A-Fa-f\\d][A-Fa-f\\d][A-Fa-f\\d])");

   public Gradient convertFromString (String string)
   {
      Matcher m = pattern.matcher (string);
      if (m.matches ())
          return new Gradient (Color.decode (m.group (1)), 
                               Color.decode (m.group (2)));
      else
          throw new IllegalArgumentException ("unable to convert string '"+
                                              string+"' to Gradient");
   }
}
