// TC.java
 
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.EventQueue;
import java.awt.FlowLayout;
import java.awt.GradientPaint;
 
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.io.FileReader;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
 
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
 
import com.sun.stylesheet.Stylesheet;
 
import com.sun.stylesheet.css.CSSParser;
 
import com.sun.stylesheet.types.TypeManager;
 
public class TC extends JFrame
{
   public TC ()
   {
      super ("Temp Converter");
      setDefaultCloseOperation (EXIT_ON_CLOSE);
 
      GPanel pnl = new GPanel ();
      pnl.setLayout (new BorderLayout ());
 
      JPanel pnlInput = new JPanel ();
      pnlInput.putClientProperty ("styleClass", "border");
      pnlInput.setOpaque (false);
      pnlInput.add (new JLabel ("Degrees:"));
      final JTextField txtInput = new JTextField (15);
      pnlInput.add (txtInput);
      pnl.add (pnlInput, BorderLayout.NORTH);
 
      JPanel pnlButtons = new JPanel ();
      pnlButtons.putClientProperty ("styleClass", "border");
      pnlButtons.setOpaque (false);
      JButton btnToCelsius = new JButton ("To Celsius");
      ActionListener alToCelsius;
      alToCelsius = new ActionListener ()
                    {
                        public void actionPerformed (ActionEvent ae)
                        {
                           try
                           {
                              double val;
                              val = Double.parseDouble (txtInput.getText ());
                              double res = (val-32.0)*5.0/9.0;
                              txtInput.setText (res+"");
                           }
                           catch (NumberFormatException nfe)
                           {
                              txtInput.setText ("error");
                           }
                        }
                    };
      btnToCelsius.addActionListener (alToCelsius);
      pnlButtons.add (btnToCelsius);
      JButton btnToFahrenheit = new JButton ("To Fahrenheit");
      ActionListener alToFahrenheit;
      alToFahrenheit = new ActionListener ()
                       {
                           public void actionPerformed (ActionEvent ae)
                           {
                              try
                              {
                                 double val;
                                 val = Double.parseDouble (txtInput.getText ());
                                 double res = val*9.0/5.0+32.0;
                                 txtInput.setText (res+"");
                              }
                              catch (NumberFormatException nfe)
                              {
                                 txtInput.setText ("error");
                              }
                           }
                       };
      btnToFahrenheit.addActionListener (alToFahrenheit);
      pnlButtons.add  (btnToFahrenheit);
      pnl.add (pnlButtons, BorderLayout.SOUTH);
 
      setContentPane (pnl);
   }
 
   public static void main (String [] args)
   {
      Runnable r;
      r = new Runnable ()
          {
              public void run ()
              {
                 TypeManager.registerTypeConverter (Gradient.class,
                                                    new GradientConverter ());
                 FileReader fr = null;
                 try
                 {
                     fr = new FileReader ("TC.css");
                     Stylesheet stylesheet = CSSParser.parse (fr);
                     TC tc = new TC ();
                     stylesheet.applyTo (tc);
                     tc.pack ();
                     tc.setResizable (false);
                     tc.setLocationRelativeTo (null);
                     tc.setVisible (true);
                 }
                 catch (FileNotFoundException fnfe)
                 {
                     System.err.println ("TC.css not found");
                 }
                 catch (IOException ioe)
                 {
                     System.err.println ("I/O problem: "+ioe.getMessage ());
                 }
                 finally
                 {
                     if (fr != null)
                         try { fr.close (); } catch (IOException ioe) {}
                 }
              }
          };
      EventQueue.invokeLater (r);
   }
}
